function varargout = BiosensorGUI(varargin)
% BIOSENSORGUI M-file for BiosensorGUI.fig
%      BIOSENSORGUI, by itself, creates a new BIOSENSORGUI or raises the existing
%      singleton*.
%
%      H = BIOSENSORGUI returns the handle to a new BIOSENSORGUI or the handle to
%      the existing singleton*.
%
%      BIOSENSORGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BIOSENSORGUI.M with the given input arguments.
%
%      BIOSENSORGUI('Property','Value',...) creates a new BIOSENSORGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before BiosensorGUI_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to BiosensorGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help BiosensorGUI

% Last Modified by GUIDE v2.5 17-May-2008 14:22:12

clc;

currentPath = which('BiosensorGUI.m');
addpath(currentPath(1:end-14));

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @BiosensorGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @BiosensorGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before BiosensorGUI is made visible.
function BiosensorGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to BiosensorGUI (see VARARGIN)

% Choose default command line output for BiosensorGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes BiosensorGUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = BiosensorGUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in startButton.
function startButton_Callback(hObject, eventdata, handles)
% hObject    handle to startButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% First let's check that the user given USB port
% is valid

% s = serial(usbPort,'BaudRate',115200);
% s.InputBufferSize = 8192;
% if fopen(s);

global data

delete(instrfind); % Free serial port if it is left open due to an error

guidata(hObject, handles);

portText = get(handles.usbPort_edit,'String');

if isempty(portText)
    % USB port number is not assigned
    errordlg('The USB port to the base station is not assigned. Fail to connect!')
    return;
end

handles.stopPlotting = 0;
handles.saveParsedData     = 0;
guidata(hObject, handles);

set(handles.startButton,'Enable','off');
set(handles.recordButton,'Enable','on');
set(handles.stopButton,'Enable','on');

set(handles.loadData,'Enable','off');
set(handles.playData,'Enable','off');
set(handles.saveData,'Enable','off');

gcfHandle = get(gcf); % Needed for extracting datas of subplots

% Start plotting & recording
data = plotMoteData_forGUI(hObject, handles, ...
  portText,str2num(get(handles.numMotes,'String')),...
  gcfHandle, 'realTime', []);
% plotMoteData_forGUI() returns only after user 
% presses stopButton or there is problems in data
% reception from the sensor

set(handles.startButton,'Enable','on');
set(handles.recordButton,'Enable','off');
set(handles.stopButton,'Enable','off');

set(handles.loadData,'Enable','on');
set(handles.playData,'Enable','off');
if ~isempty(data)
    set(handles.saveData,'Enable','on');
end

set(handles.startSave, 'String', '1');
set(handles.endSave,'String',num2str(size(data{1},1)));
        
% --- Executes on button press in stopButton.
function stopButton_Callback(hObject, eventdata, handles)
% hObject    handle to stopButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.stopPlotting = 1;
guidata(hObject, handles);
pause(0.2);

% --- Executes on button press in recordButton.
function recordButton_Callback(hObject, eventdata, handles)
% hObject    handle to recordButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.saveParsedData = 1;
guidata(hObject, handles);
set(handles.recordButton,'Enable','off');

function usbPort_edit_Callback(hObject, eventdata, handles)
% hObject    handle to usbPort_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of usbPort_edit as text
%        str2double(get(hObject,'String')) returns contents of usbPort_edit as a double


% --- Executes during object creation, after setting all properties.
function usbPort_edit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to usbPort_edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% This is to prevent closing the plot window while the plot
% is running
function my_closereq(src,evnt)
  disp('Cannot close window while plotting');


% --------------------------------------------------------------------
function plotData_Callback(hObject, eventdata, handles)
% hObject    handle to plotData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uigetfile('*.mat');
s = open([PathName FileName]);
data = s.data;
timeStamps = s.timeStamps;
disp('Processing data...');
figure;
plotAllRecordedData(data(:,2), data(:,3), data(:,4:6), data(:,7), 51.2);
disp('Done');

function Version_Callback(hObject, eventdata, handles)
% hObject    handle to Version (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Version as text
%        str2double(get(hObject,'String')) returns contents of Version as a double


% --- Executes during object creation, after setting all properties.
function Version_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Version (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function subject_Callback(hObject, eventdata, handles)
% hObject    handle to subject (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of subject as text
%        str2double(get(hObject,'String')) returns contents of subject as a double


% --- Executes during object creation, after setting all properties.
function subject_CreateFcn(hObject, eventdata, handles)
% hObject    handle to subject (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function age_Callback(hObject, eventdata, handles)
% hObject    handle to age (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of age as text
%        str2double(get(hObject,'String')) returns contents of age as a double


% --- Executes during object creation, after setting all properties.
function age_CreateFcn(hObject, eventdata, handles)
% hObject    handle to age (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function movement_Callback(hObject, eventdata, handles)
% hObject    handle to movement (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of movement as text
%        str2double(get(hObject,'String')) returns contents of movement as a double


% --- Executes during object creation, after setting all properties.
function movement_CreateFcn(hObject, eventdata, handles)
% hObject    handle to movement (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function numMotes_Callback(hObject, eventdata, handles)
% hObject    handle to numMotes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numMotes as text
%        str2double(get(hObject,'String')) returns contents of numMotes as a double


% --- Executes during object creation, after setting all properties.
function numMotes_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numMotes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on button press in playData.
function playData_Callback(hObject, eventdata, handles)
% hObject    handle to playData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    global fileName filePath

    guidata(hObject, handles);

    handles.stopPlotting = 0;
    handles.saveParsedData     = 0;
    guidata(hObject, handles);
    
    set(handles.startButton,'Enable','off');
    set(handles.recordButton,'Enable','off');
    set(handles.stopButton,'Enable','on');

    set(handles.loadData,'Enable','off');
    set(handles.playData,'Enable','off');
    set(handles.saveData,'Enable','off');


    gcfHandle = get(gcf); % Needed for extracting datas of subplots

    % Start plotting & recording
    plotMoteData_forGUI(hObject, handles, ...
      get(handles.usbPort_edit,'String'),str2num(get(handles.numMotes,'String')),...
      gcfHandle, 'parsed', [filePath fileName]);
    % plotMoteData_forGUI() returns only after user 
    % presses stopButton or there is problems in data
    % reception from the sensor
    
    set(handles.startButton,'Enable','on');
    set(handles.recordButton,'Enable','off');
    set(handles.stopButton,'Enable','off');

    set(handles.loadData,'Enable','on');
    set(handles.playData,'Enable','on');
    set(handles.saveData,'Enable','on');

% --- Executes on button press in loadData.
function loadData_Callback(hObject, eventdata, handles)
% hObject    handle to loadData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    global fileName filePath data
    handles.saveParsedData = 0;

    %saveQuestion = questdlg('Do you want to playback data?','Play data?','Yes','No','Yes');
    %if strcmp(saveQuestion, 'Yes')
    [fileName, filePath] = uigetfile();
    % In case the users choses cancel in the save dialog
    if fileName == 0
        disp('WARNING: No file chosen, no playback!');
        saveQuestion = 'No';
        set(handles.startButton,'Enable','on');
        set(handles.recordButton,'Enable','off');
        set(handles.stopButton,'Enable','off');

        set(handles.loadData,'Enable','on');
        set(handles.playData,'Enable','on');
        return;
    end
    dataType = 'raw';
    if strcmp(fileName(length(fileName)-3:length(fileName)), '.mat')
        dataType = 'parsed';
        load([filePath fileName]);
        set(handles.numMotes, 'String', num2str(length(WearableData.Reading)));
        set(handles.Version, 'String', WearableData.Version);
        set(handles.movement, 'String', WearableData.Class);
        set(handles.subject, 'String', WearableData.Subject);
        set(handles.age, 'String', WearableData.Age);
        set(handles.startSave, 'String', '1');
        set(handles.endSave,'String',num2str(size(WearableData.Reading{1},1)));
        data = WearableData.Reading;
        set(handles.saveData,'Enable','on');
    end

    set(handles.playData,'Enable','on');
    
% --- Executes on button press in saveData.
function saveData_Callback(hObject, eventdata, handles)
% hObject    handle to saveData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global data;

startDataPt    = str2num(get(handles.startSave,'String'));
endDataPt      = str2num(get(handles.endSave,'String'));

guidata(hObject, handles);

[fileName, filePath] = uiputfile();
if fileName == 0
    disp('WARNING: No file chosen, recorded data will NOT be stored!');
else
    % Truncate data if required
    numOfMotes = length(data);
    sampleCount = size(data{1},1);
    if endDataPt==0
        endDataPt = sampleCount;
        set(handles.endSave,'String',sampleCount);
    end
    if startDataPt==0
        startDataPt = 1;
        set(handles.startSave,'String',1);
    end
    if endDataPt>sampleCount
        warning('End point value is larger than the current data value. Cannot save!');
        return;
    elseif startDataPt>endDataPt
        warning('End point value is smaller than the start point value. Cannot save!');
        return;
    end
    for moteIndex=1:numOfMotes
        data{moteIndex} = data{moteIndex}(startDataPt:endDataPt,:);
    end
    set(handles.startSave, 'String', '1');
    set(handles.endSave,'String',num2str(size(data{1},1)));
    
    WearableData = struct();
    WearableData.Version=get(handles.Version,'String');
    WearableData.Date=date;
    WearableData.Class=get(handles.movement,'String');
    WearableData.Subject=get(handles.subject,'String');
    WearableData.Age=get(handles.age,'String');
    WearableData.Reading=data;
    save([filePath fileName], 'WearableData');
    disp('Recorded data saved.');
end


function startSave_Callback(hObject, eventdata, handles)
% hObject    handle to startSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of startSave as text
%        str2double(get(hObject,'String')) returns contents of startSave as a double


% --- Executes during object creation, after setting all properties.
function startSave_CreateFcn(hObject, eventdata, handles)
% hObject    handle to startSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function endSave_Callback(hObject, eventdata, handles)
% hObject    handle to endSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of endSave as text
%        str2double(get(hObject,'String')) returns contents of endSave as a double


% --- Executes during object creation, after setting all properties.
function endSave_CreateFcn(hObject, eventdata, handles)
% hObject    handle to endSave (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


